package io.github.zskamljic.restahead.demo;

import io.github.zskamljic.restahead.adapter.DefaultAdapters;
import io.github.zskamljic.restahead.client.Client;
import io.github.zskamljic.restahead.client.requests.MultiPartRequest;
import io.github.zskamljic.restahead.client.requests.Request;
import io.github.zskamljic.restahead.client.requests.Verb;
import io.github.zskamljic.restahead.client.requests.parts.FieldPart;
import io.github.zskamljic.restahead.conversion.Converter;
import io.github.zskamljic.restahead.exceptions.RestException;
import java.lang.InterruptedException;
import java.lang.Override;
import java.lang.String;
import java.util.concurrent.ExecutionException;
import javax.annotation.processing.Generated;

@Generated("Generated by RestAhead")
public final class FormWithPart$Impl implements FormWithPart {
    private final String baseUrl;

    private final Client client;

    private final Converter converter;

    private final DefaultAdapters defaultAdapters;

    public FormWithPart$Impl(String baseUrl, Client client, Converter converter,
                             DefaultAdapters defaultAdapters) {
        this.baseUrl = baseUrl;
        this.client = client;
        this.converter = converter;
        this.defaultAdapters = defaultAdapters;
    }

    @Override
    public final void post(String body) {
        var httpRequestBuilder = new Request.Builder()
            .setVerb(Verb.POST)
            .setBaseUrl(baseUrl)
            .setPath("");
        MultiPartRequest.builder()
            .addPart(new FieldPart("body", body))
            .buildInto(httpRequestBuilder);
        var response = client.execute(httpRequestBuilder.build());
        try {
            defaultAdapters.syncVoidAdapter(response);
        } catch (ExecutionException | InterruptedException exception) {
            throw RestException.getAppropriateException(exception);
        }
    }
}